# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

survLm_fit <- function(y, X, weights) {
    .Call('_rpms_survLm_fit', PACKAGE = 'rpms', y, X, weights)
}

#' Fit a linear model using data collected from a complex sample
#' 
#' @param y A vector of values
#' @param X The design matrix of the linear model  
#' @param weights A vector of sample weights for each observation 
#' @param strata A vector of strata labels
#' @param clusters A vector of cluster labels
#' 
#' @return list containing coefficients, covariance matrix and the residuals
#' 
#' @keywords internal
#' 
survLm_model <- function(y, X, weights, strata, clusters) {
    .Call('_rpms_survLm_model', PACKAGE = 'rpms', y, X, weights, strata, clusters)
}

null_split <- function() {
    .Call('_rpms_null_split', PACKAGE = 'rpms')
}

rbind_splits <- function(split1, split2) {
    .Call('_rpms_rbind_splits', PACKAGE = 'rpms', split1, split2)
}

get_node <- function(node, cat, vname, y, weights, mxval, s, modfit) {
    .Call('_rpms_get_node', PACKAGE = 'rpms', node, cat, vname, y, weights, mxval, s, modfit)
}

get_loss <- function(x, x_val, y, mX, weights) {
    .Call('_rpms_get_loss', PACKAGE = 'rpms', x, x_val, y, mX, weights)
}

small_loss <- function(x_val, uq_xs, y, mX, weights, Lx, Ux, Lloss, Uloss, gridpts) {
    .Call('_rpms_small_loss', PACKAGE = 'rpms', x_val, uq_xs, y, mX, weights, Lx, Ux, Lloss, Uloss, gridpts)
}

small_loss_cat <- function(sets, cats, x_val, y, mX, weights, cat_ind, Lx, Ux, Lloss, Uloss, gridpts) {
    .Call('_rpms_small_loss_cat', PACKAGE = 'rpms', sets, cats, x_val, y, mX, weights, cat_ind, Lx, Ux, Lloss, Uloss, gridpts)
}

split_rpms <- function(node, y, mX, X, vnames, cat_vec, weights, strata, clusters, des_ind, bin_size, gridpts, perm_reps, pval) {
    .Call('_rpms_split_rpms', PACKAGE = 'rpms', node, y, mX, X, vnames, cat_vec, weights, strata, clusters, des_ind, bin_size, gridpts, perm_reps, pval)
}

random_split2 <- function(node, y, mX, X, vnames, cat_vec, weights, strata, clusters, des_ind, bin_size) {
    .Call('_rpms_random_split2', PACKAGE = 'rpms', node, y, mX, X, vnames, cat_vec, weights, strata, clusters, des_ind, bin_size)
}

random_split <- function(node, y, mX, X, vnames, cat_vec, weights, strata, clusters, des_ind, bin_size, randv) {
    .Call('_rpms_random_split', PACKAGE = 'rpms', node, y, mX, X, vnames, cat_vec, weights, strata, clusters, des_ind, bin_size, randv)
}

clus_perm <- function(res, C, clus_indx, effs, M) {
    .Call('_rpms_clus_perm', PACKAGE = 'rpms', res, C, clus_indx, effs, M)
}

perm <- function(res, M) {
    .Call('_rpms_perm', PACKAGE = 'rpms', res, M)
}

